Subject: Re: bug#10387: CODE wishlist: search-prop.el

From: Juri Linkov <[email-masked]>
Date: Sun, 24 Nov 2013 01:34:00 +0200

> I was not aware of this bug thread - just came across it when scanning
> the list of patch bugs that Glenn pointed to in emacs-devel today.
>
> I only skimmed this thread, so ignore if my input is not relevant.

I'm not sure whether this feature request was about low-level
search functions or more user-oriented isearch commands.
Both can be easily implemented by using `isearch-filter-predicate'.

But it seems the request has nothing to do with the text search
and asks for a better replacement of `next-property-change'.
Indeed, such functions could provide a similar interface
(function names and argument names) like in isearch functions
and maybe even reuse some code e.g. wrapping, direction, etc.

One idea is to define `isearch-search-fun-function' in such a way
that it will interpret its argument `string' as the name
of the property to search.  Then new isearch sub-mode
will allow searching by property names.

> By default, the zones not being searched are dimmed a bit.
> `C-M-~' toggles, to search the zones that do *not* have the
> particular property values.  For example, with a command such as
> `isearchp-imenu-command', which normally searches Emacs-Lisp
> command definitions (after putting a property on them),
> `C-M-~' makes it search all text other than command definitions.

`C-M-~' is a strange choice and it can't be typed on tty.
There is a special sub-map for filter commands on `M-s f'.